#include "mesh.h"
#include <string>
#include "filereader.h"
#include <QDebug>
#include <QGLWidget>

using namespace std;

void Mesh::loadOFF(const QString &filename)
{
	FileReader stream(filename.toStdString());
	if (!stream.isOpen())
		return;
	string line;
	stream >> line;
	const bool b_color = line == "COFF";
	if (line != "OFF" && line != "COFF")
		return;

	u_int32_t nb_vtx, nb_idx, nb_edg;
	stream >> nb_vtx >> nb_idx >> nb_edg;

	vertex.reserve(nb_vtx);
	for(size_t i = 0 ; i < nb_vtx ; ++i)
	{
		Vec3 p;
		stream >> p[0] >> p[1] >> p[2];
		vertex.push_back(p);
		if (b_color)
		{
			Vec3 c;
			stream >> c[0] >> c[1] >> c[2];
		}
	}
	index.reserve(nb_idx * 3);
	for(size_t i = 0 ; i < nb_idx ; ++i)
	{
		u_int32_t n;
		stream >> n;
		if (n < 2)
		{
			u_int32_t k;
			for(u_int32_t j = 0 ; j < n ; ++j)
				stream >> k;
			continue;
		}
		u_int32_t a, b;
		stream >> a >> b;
		for(u_int32_t j = 2 ; j < n ; ++j)
		{
			index.push_back(a);
			index.push_back(b);
			stream >> b;
			index.push_back(b);
		}
	}

	primitive_type = GL_TRIANGLES;

	recompute_normals();
}
